#include <iostream>
#include <stdio.h>
#include <string.h>
//Free
#include <stdlib.h>
//Scan Directory
#include <dirent.h>
#include<sys/stat.h>
#include<sys/types.h>
#include "fstream"
#include "C_c.cpp"
#define buffer_size 1024
#define max_filename_len 2044
#define standard_dic_size 65535

using namespace std;


//CPack Class
class CPack {
ofstream file_out;
ifstream file_in;
//Private vars
char buffer[buffer_size];

//Public vars
public:
	char * input;
	char * output;
	bool append;
	CPack ();
	void SetFilenames(char *, char *);
	void Pack();
	void PackDir(char *);
	void UnPack();
	long long GetfileSize( char*  );
	bool DirectoryExists( char*  );
	bool verbose;
	bool compress;
	unsigned char * write_buffer;
	//Class ulzw declared
	ulzw compr;
};

CPack::CPack () {
append = false;
verbose = false;

write_buffer =  (unsigned char *) malloc(standard_dic_size);
}

void CPack::SetFilenames (char * in, char *out) {

int len = strlen(in);
if ( in[len-1] == '/' )
in[len-1] = '\0';

len = strlen(out);
if ( out[len-1] == '/' )
out[len-1] = '\0';

input = in;
output = out;
}

long long CPack::GetfileSize(char * filePath){
  long long begin, end;
  ifstream myfile (filePath);
  begin = myfile.tellg();
  myfile.seekg (0, ios::end);
  end = myfile.tellg();
  myfile.close();
  return (end-begin);
}


void CPack::PackDir (char *path) {

	struct dirent **namelist;
	int n;
	n = scandir(path, &namelist, 0, alphasort);
	
	if (n > 0)
	{
		while (n--) {
				if ( (namelist[n]->d_name[0] != '.' ||  strlen(namelist[n]->d_name) != 1 ) && ((namelist[n]->d_name[0] != '.' && namelist[n]->d_name[1] != '.') || strlen(namelist[n]->d_name) != 2 )){
				char full_name[max_filename_len];
				char arc_name[max_filename_len];
				bzero(full_name,max_filename_len);

				strcpy(full_name, path);
				strcat(full_name, "/");
				strcat(full_name, namelist[n]->d_name);

				if (path[0] != '.' && path[1] !='\0' ){
				strcpy(arc_name,full_name);
				}
				else
				{
				strcpy(arc_name, namelist[n]->d_name);
				}

				if (DirectoryExists(full_name) == false){
				
				
				if ( compress == false ||  GetfileSize(full_name) < 10 )
				{

				long long fsize = GetfileSize(full_name);
				if ( verbose == true )
				cout<<"Adding "<<full_name<<"- ("<<fsize<<"  bytes).."<<endl;

				//Type 0 : File
				file_out.put(0);

				//Filename Len
				file_out.put( strlen(arc_name) / 256 );
				file_out.put( strlen(arc_name) % 256 );

				//Filename 
				file_out.write( arc_name, strlen(arc_name) );

				//Filename Size
				file_out.put( fsize/(4294967296L) );
				file_out.put( fsize/(256*256*256) );
				file_out.put( fsize/(256*256) );
				file_out.put( fsize / 256 );
				file_out.put( fsize % 256 );
				
				//Write File
				file_in.open(full_name,ios::in | ios::binary );

				long long readen = 0;
				int to_read = 0;				
				while ( readen < fsize )
				{

				if (readen + buffer_size > fsize)
				to_read = fsize - readen; 
				else
				to_read = buffer_size;
				file_in.read(buffer,to_read);
				
				file_out.write( buffer, to_read );
				readen += to_read;
				}
				file_out.flush();
				file_in.close();
				}
				else
				{
				long long fsize = GetfileSize(full_name);
				long long cfsize = 0;
				if ( verbose == true )
				cout<<"Adding "<<full_name<<"- ("<<fsize<<"  bytes)"<<endl;
				//Type 2: Compressed file! 
				file_out.put(2); 
				//Filename Len
				file_out.put( strlen(arc_name) / 256 );
				file_out.put( strlen(arc_name) % 256 );
				//Filename 
				file_out.write( arc_name, strlen(arc_name) );
				long long pos=file_out.tellp();
				//Filename Size temp
				file_out.put( cfsize/(4294967296L) );
				file_out.put( cfsize/(256*256*256) );
				file_out.put( cfsize/(256*256) );
				file_out.put( cfsize / 256 );
				file_out.put( cfsize % 256 );

				//Compression flag
				int flag = 0;
				int chr = 0;
				int recv = 0;
				
				file_out.close();
				//Read File
				file_in.open(full_name,ios::in | ios::binary );

				long long readen = 0;
				long long compressed_size = 0;
				int to_read = 0;		
				int print_after = 0;
				unsigned char write_buffer[100000];
				
				while ( readen < fsize )
				{

				if (readen + buffer_size > fsize)
				to_read = fsize - readen; 
				else
				to_read = buffer_size;
				
				file_in.read(buffer,to_read);
				readen+= to_read;
				
				recv = compr.compress_buffer_to_file( (unsigned char *)buffer, to_read, output, flag, 1);
				flag = 1;
				compressed_size+= recv;
	
				if ( print_after == 1000 )
				{
					if( verbose == true )
					if (fsize>=100)
					printf("\r %i % (%ld bytes processed)", readen/(fsize/100), readen );
					print_after =0;
				}
				print_after++;
				
				}

				flag = 3 ;
				recv = compr.compress_buffer_to_file( (unsigned char *)buffer, 0, output, flag, 1);
				file_in.close();
				compressed_size+= recv;
				if( verbose == true )
				if (fsize>=100)
				printf("\r %i % (%ld bytes processed)", readen/(fsize/100), readen );
				
				if( verbose == true )
				if (fsize>=100)
				cout<<endl<<"Compressed size: "<<compressed_size<<" - compression ratio "<<((compressed_size/(fsize/100)))<<" %"<<endl<<endl;
				
				file_out.open(output, ios::in|ios::out|ios::binary);
				file_out.seekp (pos);
			//	cout<<"Position "<<file_out.tellp()<<endl;
			//	cout<<"Writing compressed size "<<compressed_size<<endl;
				//Filename Size compressed
				file_out.put( compressed_size/(4294967296L) );
				file_out.put( compressed_size/(256*256*256) );
				file_out.put( compressed_size/(256*256) );
				file_out.put( compressed_size / 256 );
				file_out.put( compressed_size % 256 );

				file_out.seekp (0,ios::end);

				}
				}
				else
				{

				//Type 1 : Directory
				file_out.put(1);

				//Directory Len
				file_out.put( strlen(arc_name) / 256 );
				file_out.put( strlen(arc_name) % 256 );

				//Filename 
				file_out.write( arc_name, strlen(arc_name) );
				file_out.flush();
				if ( verbose == true )
				printf("Adding Directory: %s\n", arc_name);
				PackDir(full_name);
				}
}
			free(namelist[n]);
	}
}
free(namelist);
}

void CPack::Pack () {

if ( append == false )
file_out.open(output, ios::out|ios::binary);
else
file_out.open(output, ios::out|ios::binary|ios::app);


file_out.put(compr.dictionary_bits);

if (DirectoryExists(input) == true){
//Type 1 : Directory
file_out.put(1);

//Directory Len
file_out.put( strlen(input) / 256 );
file_out.put( strlen(input) % 256 );

//Filename 
file_out.write( input, strlen(input) );
file_out.flush();
if ( verbose == true )
printf("Adding Directory: %s\n", input);

PackDir(input);
}
else if ( compress == false ||  GetfileSize(input) < 10 )
{


long long fsize = GetfileSize(input);
if ( verbose == true )
cout<<"Adding "<<input<<"- ("<<fsize<<"  bytes)"<<endl;

//Type 0 : File
file_out.put(0);

//Filename Len
file_out.put( strlen(input) / 256 );
file_out.put( strlen(input) % 256 );

//Filename 
file_out.write( input, strlen(input) );

//Filename Size
file_out.put( fsize/(4294967296L) );
file_out.put( fsize/(256*256*256) );
file_out.put( fsize/(256*256) );
file_out.put( fsize / 256 );
file_out.put( fsize % 256 );

//Write File
file_in.open(input,ios::in | ios::binary );

long long readen = 0;
int to_read = 0;
while ( readen < fsize )
{

if (readen + buffer_size > fsize)
to_read = fsize - readen; 
else
to_read = buffer_size;


file_in.read(buffer,to_read);
file_out.write( buffer, to_read );
readen += to_read;
}
file_out.flush();
file_in.close();

}
else
{
long long fsize = GetfileSize(input);
long long cfsize = 0;
if ( verbose == true )
cout<<"Adding "<<input<<"- ("<<fsize<<"  bytes)"<<endl;
//Type 2: Compressed file! 
file_out.put(2); 
//Filename Len
file_out.put( strlen(input) / 256 );
file_out.put( strlen(input) % 256 );
//Filename 
file_out.write( input, strlen(input) );
long long pos=file_out.tellp();
//Filename Size temp
file_out.put( cfsize/(4294967296L) );
file_out.put( cfsize/(256*256*256) );
file_out.put( cfsize/(256*256) );
file_out.put( cfsize / 256 );
file_out.put( cfsize % 256 );

//Compression flag
int flag = 0;
int chr = 0;
int recv = 0;

file_out.close();
//Read File
file_in.open(input,ios::in | ios::binary );

long long readen = 0;
long long compressed_size = 0;
int to_read = 0;		
int print_after = 0;
unsigned char write_buffer[100000];

while ( readen < fsize )
{

if (readen + buffer_size > fsize)
to_read = fsize - readen; 
else
to_read = buffer_size;

file_in.read(buffer,to_read);
readen+= to_read;

recv = compr.compress_buffer_to_file( (unsigned char *)buffer, to_read, output, flag, 1);
flag = 1;
compressed_size+= recv;
	
if ( print_after == 1000 )
{
	if( verbose == true )
	if (fsize>=100)
	printf("\r %i % (%ld bytes processed)", readen/(fsize/100), readen );
	print_after =0;
}
print_after++;

}

flag = 3 ;
recv = compr.compress_buffer_to_file( (unsigned char *)buffer, 0, output, flag, 1);
file_in.close();
compressed_size+= recv;
if( verbose == true )
if (fsize>=100)
printf("\r %i % (%ld bytes processed)", readen/(fsize/100), readen );

if( verbose == true )
if (fsize>=100)
cout<<endl<<"Compressed size: "<<compressed_size<<" - compression ratio "<<((compressed_size/(fsize/100)))<<" %"<<endl<<endl;

file_out.open(output, ios::in|ios::out|ios::binary);
file_out.seekp (pos);

//Filename Size compressed
file_out.put( compressed_size/(4294967296L) );
file_out.put( compressed_size/(256*256*256) );
file_out.put( compressed_size/(256*256) );
file_out.put( compressed_size / 256 );
file_out.put( compressed_size % 256 );
file_out.seekp (0,ios::end);
}
file_out.close();
append = true;
}

void CPack::UnPack () {

if(mkdir(output,0777)==-1)//creating a directory
{
if ( verbose == true )
cout<<"Error while making "<<output<<endl;
}
else
if ( verbose == true )
cout<<"Directory "<<output<<" created!"<<endl;

//Get the file size
long long fsize = GetfileSize(input);
long long readen = 0;

int to_read = 0;
if ( verbose == true )
cout<<"Opening "<<input<<endl;

file_in.open(input, ios::out|ios::binary);

int dic_bits = file_in.get();
compr.set_dictionary_size(dic_bits);
readen++;
while (readen < fsize )
{
	int type = file_in.get();
	readen++;
	
	
	//cout<<"Type "<<type<<endl;
	int name_len = ( ((file_in.get()*256) + file_in.get()) );
	readen += 2;
	
	//cout<<"Name Len "<<name_len<<endl;
	char unpack_name[max_filename_len];
	bzero(unpack_name,max_filename_len);
	file_in.read(unpack_name, name_len);
	readen += name_len;
		
	char full_name[max_filename_len];
	bzero(full_name,max_filename_len);

	strcpy(full_name, output);
	strcat(full_name, "/");
	strcat(full_name, unpack_name);
	
	//if ( verbose == true )
//	cout<<" "<<full_name;

	//Directory
	if (type == 1){
	if(mkdir(full_name,0777)==-1)//creating a directory
	{
	if ( verbose == true )
	cout<<"Error while making "<<full_name<<endl;
	}
	else
	if ( verbose == true )
	cout<<"Directory "<<full_name<<" created!"<<endl;
	}

	
    //File
	if (type == 0){
	file_out.open(full_name, ios::out|ios::binary);
	long long the_file_size = (  ( (long long)(file_in.get()*256*256*256*256) +  (long long)(file_in.get()*256*256*256) + (long long)(file_in.get()*256*256) + (long long)(file_in.get()*256) + (long long)file_in.get()) );
	long long the_file_readen = 0;
	readen += 5;
	if ( verbose == true )
	cout<<"Extracting "<<full_name<<" ( "<<the_file_size<<" bytes )"<<endl;
	
	while( the_file_readen <  the_file_size)
	{
	int data_to_read = 0;
	if ( the_file_readen + buffer_size > the_file_size )
	data_to_read = the_file_size - the_file_readen;
	else
	data_to_read = buffer_size;
	file_in.read(buffer, data_to_read);
	file_out.write(buffer, data_to_read);
	the_file_readen += data_to_read;
	readen+= data_to_read;
	}
	file_out.close();
	}
	
	
	
	 //Compressed file
	if (type == 2){

	long long the_file_size = (  ( (long long)(file_in.get()*256*256*256*256) +  (long long)(file_in.get()*256*256*256) + (long long)(file_in.get()*256*256) + (long long)(file_in.get()*256) + (long long)file_in.get()) );
	long long the_file_readen = 0;
	readen += 5;
	
	if ( verbose == true )
	cout<<endl<<"Extracting "<<full_name<<" ( "<<the_file_size<<" bytes )"<<endl;
	
	int flag = 0;
	int recv = 0;
	int chr = 0;
	int perc = 0;
	unsigned char getperc[2];
	unsigned char bufferd[1024];
	int print_after = 0;	
	long long total_size = the_file_size;
	long long total_recv = 0;
	long long size_processed = 0;
	


	while( size_processed <  the_file_size)
	{
	int data_to_read = 0;
	if ( size_processed + buffer_size > the_file_size )
	data_to_read = the_file_size - size_processed;
	else
	data_to_read = buffer_size;
	

	
	file_in.read(buffer, data_to_read);
	size_processed += data_to_read;
	readen+= data_to_read;

//	cout<<"readen "<<data_to_read<<" bytes "<<endl;
	recv = compr.decompress_buffer_to_file((unsigned char*)buffer, data_to_read, full_name, flag);
	total_recv += recv;
	

	if ( print_after == 1000 ){
	if(verbose == true)
	if ( the_file_size >= 100 )
	printf("\r %i % (received %ld bytes)", size_processed/(the_file_size/100), total_recv);
	print_after = 0;
	}
	print_after++;

	flag = 2;
	}
	flag = 3;
	recv = compr.decompress_buffer_to_file((unsigned char*)buffer, 0, full_name, flag);
	if(verbose == true)
	if ( the_file_size >= 100 )
	printf("\r %i % (received %ld bytes)", size_processed/(the_file_size/100), total_recv);
	}

}
file_in.close();

}
//END CPack CLASS

bool CPack::DirectoryExists( char* pzPath )
{
    if ( pzPath == NULL) return false;
    DIR *pDir;
    bool bExists = false;
    pDir = opendir (pzPath);
    if (pDir != NULL)
    {
        bExists = true;    
        (void) closedir (pDir);
    }
    return bExists;
}


int main (int argc, char ** argv) {

if (argc < 3 )
{
cout<<endl<<"-- Pack Usage --"<<endl<<endl;
cout<<"Create pack file"<<endl<<"\tpack -c destination source1 source2 ... source x"<<endl<<endl;
cout<<"Extract pack file"<<endl<<"\tpack -x source destination"<<endl<<endl;
cout<<"Others options (write letters after the Create or Extract option)"<<endl<<"\t v verbose mode"<<endl<<"\t u compress ulzw"<<endl<<"\t sXX set the dictionary size replace XX with number from 10 to 30 (default size 16) "<<endl<<endl;
return 0;
}
else
{
CPack pack;


int alen = 0;
alen = strlen(argv[1] );

for ( int x = 0; x < alen; x++ )
{
if (argv[1][x] == 'v')
pack.verbose = true;
if (argv[1][x] == 'u'){
pack.compress = true;
cout<<"Data compression on"<<endl;
}
if (argv[1][x] == 's'){
char newsize[3];
newsize[0] = argv[1][x+1];
newsize[1] = argv[1][x+2];
newsize[3] = 0;
int new_size = atoi(newsize);
pack.compr.set_dictionary_size(new_size);

free(pack.write_buffer);
int new_buffer_size = (1 << (new_size) ) - 1;
pack.write_buffer =  (unsigned char *) malloc(new_buffer_size);
}
}


//Create archive
if ( argv[1][1] == 'c' )
{
	for (int i = 3; i < argc; i++ )	
	{
	  //Enable the * char
  	if ( argv[i][ strlen(argv[i]-1) ] == '*' )
  	argv[i][ strlen(argv[i]-1) ] = '.';

	cout<<"Packing "<<argv[i]<<endl;
	pack.SetFilenames(argv[i], argv[2]);
	pack.Pack();
	cout<<"All done"<<endl;
	}
}

//Extract archive
if ( argv[1][1] == 'x' )
{
if (argc < 4 )
{ 
 char current_path[2];
 current_path[0] = '.';
 current_path[1] = '\0';
 pack.SetFilenames(argv[2], current_path);
}
else
{
 pack.SetFilenames(argv[2], argv[3]);
}
cout<<"Unpacking "<<argv[2]<<endl;
pack.UnPack();
cout<<"All done"<<endl;
}
return 0;
}
}
